#include "tg_common.glsl"

#ifdef _FRAGMENT_

//-----------------------------------------------------------------------------

float   HeightMapTerra(vec3 point)
{
    // Global landscape
    vec3  p = point * mainFreq + Randomize;
    noiseOctaves = 5;
    vec3  distort = 0.35 * Fbm3D(p * 2.37);
    noiseOctaves = 4;
    distort += 0.008* (1.0 - abs(Fbm3D(p * 132.3)));




noiseOctaves = 8;
    float global = 0.98 - Cell3Noise(p + distort)+  ( 0.02 * (1.5 - RidgedMultifractal(point * 0.001* hillsFreq/(hillsMagn*hillsMagn) + Randomize, 2.0)));


float terrain =  hillsMagn * ((0.01 * RidgedMultifractal(point * hillsFreq + Randomize, 2.0)) + 0.6* RidgedMultifractalErodedDetail(point * ( 0.14 * montesFreq)/(montesSpiky*montesSpiky) + Randomize, 2.0, 1 * erosion, global)) - 0.01* RidgedMultifractalErodedDetail(point * ( 0.04 * montesFreq)/(montesSpiky*montesSpiky) + Randomize, 2.0, 2 *erosion, global)* 6 * hillsMagn * JordanTurbulence(point * hillsFreq + Randomize, 0.8, 0.5, 0.6, 0.35, 1.0, 0.8, 1.0);

terrain *= 1.0 - smoothstep(0.1, 0.06, global - seaLevel);;

if ( global - seaLevel > 0.01)
{
global = global + terrain;
}
 
else
{
global = global;
}

    // Venus-like structure
    float venus = 0.0;
    if (venusMagn > 0.05)
    {
        noiseOctaves = 4;
        distort = Fbm3D(point * 0.3) * 1.5;
        noiseOctaves = 6;
        venus = Fbm((point + distort) * venusFreq) * venusMagn;
    }

    global = (global + venus - seaLevel) * 0.5 + seaLevel;
    float shore = saturate(70.0 * (global - seaLevel));

    vec4  col;
    noiseOctaves = 6;
    p = p * 2.3 + 13.5 * Fbm3D(p * 0.06);
    vec2  cell = Cell3Noise2Color(p, col);
    float biome = col.r;
    float biomeScale = saturate(2.0 * (pow(abs(cell.y - cell.x), 0.7) - 0.05));
    float terrace = col.g;
    float terraceLayers = max(col.b * 10.0 + 3.0, 3.0);
    terraceLayers += Fbm(p * 5.41);

    float montRage = saturate(DistNoise(point * 22.6 + Randomize, 2.5) + 0.5);
    montRage *= montRage;
    float montBiomeScale = min(pow(2.2 * biomeScale, 2.5), 1.0) * montRage;

    float inv2montesSpiky = 1.0 /(montesSpiky*montesSpiky);
    float height = 0.0;
    float dist;

    if (biome < dunesFraction)
    {
        // Dunes
        noiseOctaves = 2.0;
    }
    else if (biome < hillsFraction)
    {
        // "Eroded" hills
        noiseOctaves = 10.0;
        noiseH       = 1.0;
        noiseOffset  = 1.0;
        height = biomeScale * hillsMagn * (0.05 - (0.4 * RidgedMultifractal(point * hillsFreq + Randomize, 2.0)) + 0.3* RidgedMultifractalErodedDetail(point *  montesFreq + Randomize, 2.0, 1.1 * erosion, biomeScale));
    }
    else if (biome < hills2Fraction)
    {
        // "Eroded" hills 2
        noiseOctaves = 10.0;
        noiseLacunarity = 2.0;
        height = 0.4 * biomeScale * hillsMagn * JordanTurbulence(point * hillsFreq + Randomize, 0.8, 0.5, 0.6, 0.35, 1.0, 0.8, 1.0);
    }
    else if (biome < canyonsFraction)
    {
        // Canyons
        noiseOctaves = 5.0;
        noiseH       = 0.9;
        noiseLacunarity = 4.0;
        noiseOffset  = montesSpiky;
        height = -canyonsMagn * montRage * RidgedMultifractalErodedDetail(point * 4.0 * canyonsFreq * inv2montesSpiky + Randomize, 2.0, erosion, montBiomeScale);

        //if (terrace < terraceProb)
        {
            terraceLayers *= 5.0;
            float h = height * terraceLayers;
            height = (floor(h) + smoothstep(0.1, 0.9, fract(h))) / terraceLayers;
        }
    }
    else
    {
        // Mountains
        noiseOctaves = 10.0;
        noiseH       = 1.0;
        noiseLacunarity = 2.3;
        noiseOffset  = montesSpiky;
        height = 0.75 *montesMagn * montRage * RidgedMultifractalErodedDetail(point * (0.9 * montesFreq) * inv2montesSpiky + Randomize, 4.0, 1.2 *erosion , montBiomeScale);

        if (terrace < terraceProb)
        {
            float h = height * 0.75 *terraceLayers;
            height = (floor(h) + smoothstep(0.1, 0.9, fract(h))) / terraceLayers;
        }


    }

    height *= shore;

    // Mare
    float mare = global;
    float mareFloor = global;
    float mareSuppress = 1.0;


if (riversOctaves > 0)
{
mare = global;
}
else
{
if (mareSqrtDensity > 0.05) 
    {
        //noiseOctaves = 2;
        //mareFloor = 0.6 * (1.0 - Cell3Noise(0.3*p));
        noiseH           = 0.5;
        noiseLacunarity  = 2.218281828459;
        noiseOffset      = 0.8;
        craterDistortion = 1.0;
        noiseOctaves     = 6.0;  // Mare roundness distortion
        mare = MareNoise(point, global, 0.0, mareSuppress);
    }
}
    

    // Craters
    float crater = 0.0;
    if (craterSqrtDensity > 0.05)
    {
        noiseOctaves = 3;  // Craters roundness distortion
        craterDistortion = 1.0;
        craterRoundDist  = 0.03;
        heightFloor = -0.1;
        heightPeak  = 0.4;
        heightRim   = 0.7;
        crater = CraterNoise(point, 0.5 * craterMagn, craterFreq, craterSqrtDensity, craterOctaves);
        noiseOctaves = 10.0;
        noiseH       = 1.0;
        noiseOffset  = 1.0;
        crater = RidgedMultifractalErodedDetail(point * 0.3 * montesFreq + Randomize, 2.0, erosion, 0.25 * crater);
    }

    height += mare + crater;

    // Pseudo rivers
    if (riversOctaves > 0)
    {
noiseOctaves = 5.0;
        noiseH       = 1.0;
        noiseLacunarity = 4.0;
       
        p = point *5* mainFreq + Randomize;
        distort  = 0.035 * Fbm3D(p * riversSin * 10.0);
        distort += 0.350 * Fbm3D(p * riversSin);
        cell =  1 * Cell3Noise2(riversFreq * p + distort);
        float pseudoRivers = 1.0 - (saturate(0.6 *  abs(cell.y - cell.x) * riversMagn))- canyonsMagn * montRage * RidgedMultifractalErodedDetail(point * 4.0 * canyonsFreq * inv2montesSpiky + Randomize, 2.0, 200 *erosion, montBiomeScale);
        pseudoRivers = smoothstep(0.0, 1.0, pseudoRivers); 
        pseudoRivers *= 1.0 - smoothstep(0.03, 0.04, global - seaLevel); // disable rivers inside continents
        pseudoRivers *= 1.0 - smoothstep(0.00, 0.01, seaLevel - height); // disable rivers inside oceans
        height = mix(height, seaLevel-0.01, pseudoRivers);
    }

else
    {
        noiseOctaves = 5.0;
        noiseH       = 1.0;
        noiseLacunarity = 4.0;
        noiseOffset  = montesSpiky;
       
        noiseOffset  = 1/(montesSpiky);
        p = point *0.2* mainFreq + Randomize;
        distort  = 0.035 * Fbm3D(p * riversSin * 7.5);
        distort += 0.350 * Fbm3D(p * riversSin);
        cell =  1 * Cell3Noise2(riversFreq * p + distort);
        float valleys = 1.0 - (saturate(2.05 *  abs(cell.y - cell.x) * riversMagn))-  canyonsMagn * montRage * RidgedMultifractalErodedDetail(point * 4.0 * canyonsFreq * inv2montesSpiky + Randomize, 2.0, 200*erosion, montBiomeScale);
        valleys = smoothstep(0.0, 0.8, valleys );
        valleys *= 1.0 - smoothstep(0.09, 0.11, global - seaLevel); // disable rivers inside continents
        valleys *= 1.0 - smoothstep(0.00, 0.12, seaLevel - global); // disable rivers inside oceans
        height = mix(height, seaLevel-0.03, valleys);
}



    // Shield volcano
noiseLacunarity = 2.218281828459; 
noiseH = 0.5; 
    if (volcanoOctaves > 0)
        height = VolcanoNoise(point, global, height);

    // Assign a climate type
    noiseOctaves = (cloudsStyle == 1.0) ? 5.0 : 12.0;
    noiseH          = 0.5;
    noiseLacunarity = 2.218281828459;
    noiseOffset     = 0.8;
    float latitude;
    if (tidalLock <= 0.0)
    {
        latitude = abs(point.y);
        latitude += 0.15 * (Fbm(point * 0.7 + Randomize) - 1.0);
        latitude = saturate(latitude);
    }
    else
    {
        latitude = 1.0 - point.x;
        latitude += 0.15 * (Fbm(point * 0.7 + Randomize) - 1.0);
    }
	
	/*
    // Ice caps
    float iceCap;
    if (cloudsStyle == 1.0)
    {
        iceCap = saturate(15.0 * (latitude - latIceCaps));
        height = height * 0.1 + icecapHeight * iceCap;
    }
    else
    {
        iceCap = saturate(3.0 * (latitude - latIceCaps));
        height += icecapHeight * sqrt(iceCap);
    }
/*
    // Ice caps
    float iceCap = saturate((latitude / latIceCaps - 1.0) * 50.0);
    height = max(height, icecapHeight * iceCap);
/**/
    // Ice caps;
    // cloudsStyle = 0.1 for oceania, 1.0 for other planets
    float iceCap = saturate((latitude / latIceCaps - 1.0) * 50.0 * cloudsStyle);
    height = height * cloudsStyle + ( 0.5 * icecapHeight) * smoothstep(0.0, 1.0, iceCap);
/**/
    //cell = Cell3Noise2(point * 103.7 + Randomize);
    //float glacier = smoothstep(0.1, 0.5, (abs(cell.y - cell.x)));

    //noiseOctaves = 5.0;
    //noiseH       = 0.9;
    //noiseLacunarity = 4.0;
    //noiseOffset  = montesSpiky;
    //float glacier;
    //glacier = RidgedMultifractalDetail(point * canyonsFreq * inv2montesSpiky + Randomize, 2.0, iceCap);

    //height = 1.0 - 0.03 * icecapHeight * glacier;
    //height = max(height, iceCap * glacier);

    return height;
}

//-----------------------------------------------------------------------------

void main()
{
    vec3  point = GetSurfacePoint();
    float height = HeightMapTerra(point);
    OutColor = vec4(height);
}

//-----------------------------------------------------------------------------

#endif
